﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using IDTechSDK;

namespace USDKDemo
{
    public partial class Decrypt : Form
    {
        public Decrypt()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if ((tBDK.Text.Length + tbIPEK.Text.Length) != 32)
            {
                tResults.Text = "BDK or IPEK Error.  Provide a BDK or IPEK, and make sure they are 16 bytes (32 characters)";
                return;
            }
            if (tKSN.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tKSN.Text.Length > 20)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if ((tKSN.Text.Length % 2) == 1)
            {
                tResults.Text = "KSN incorrect";
                return;
            }
            if (tbPAN.Text.Length > 0 && (tbPAN.Text.Length < 13 || tbPAN.Text.Length > 19))
            {
                tResults.Text = "Please enter valid PAN between 13 and 19 digits";
                return;
            }
            if (tbPAN.Text.Length > 0 && rbEncrypt.Checked && (tbASCII.Text.Length == 0 || tbASCII.Text.Length > 14))
            {
                tResults.Text = "Please enter valid PIN to encrypt, between 1 and 14 digits";
                return;
            }
            int type = 1; if (aes.Checked) type = 2;
            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdes.Checked);
            data.isDecryption = (rbDecrypt.Checked);
            if (rbData.Checked)
                data.keyVariant = 0;
            else if (rbPIN.Checked)
                data.keyVariant = 1;
            else
                data.keyVariant = 2;
            if (tdes.Checked)
            {
                if (rbType3.Checked) data.PINBlockType = 3;
            }
            else
            {
                data.PINBlockType = 4;
            }
            data.KSN = new byte[10];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSN.Text);
            int offset = 10 - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length); data.BDK = Common.getByteArray(tBDK.Text);
            data.IPEK = Common.getByteArray(tbIPEK.Text);
            data.PAN = tbPAN.Text;
            data.dataToProcess = Common.getByteArray(tEncryptedData.Text);

            if (data.PAN != null && data.PAN.Length > 0 && data.isDecryption)
            {
                if (data.dataToProcess.Length != 8 && data.isTDES)
                {
                    tResults.Text = "PIN Block must be 8 bytes";
                    return;
                }
                else if (data.dataToProcess.Length != 16 && !data.isTDES)
                {
                    tResults.Text = "PIN Block must be 16 bytes";
                    return;
                }

                if (data.isTDES)
                {
                    data.pinBlock = new byte[8];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 8);
                }
                else
                {
                    data.pinBlock = new byte[16];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 16);
                }
            }

            if (!data.isDecryption) data.dataToProcess = Encoding.ASCII.GetBytes(tbASCII.Text);

            if (Common.processDUKPT(ref data))
            {

                if (data.PAN != null && data.PAN.Length > 0)
                {
                    if (data.isDecryption)
                    {
                        tResults.Text = "PIN = " + data.PIN;
                    }
                    else
                    {
                        tResults.Text = "PIN Block= " + Common.getHexStringFromBytes(data.pinBlock);

                    }
                }
                else
                {
                    tResults.Text = Common.getHexStringFromBytes(data.dataResults) + "\r\n\r\n" + System.Text.Encoding.UTF8.GetString(data.dataResults);
                }



            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }
            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);
            if (data.PAN != null && data.PAN.Length > 0)
            {
                tResults.Text = tResults.Text +
    "\r\n\r\n       PIN Block:  " + Common.getHexStringFromBytes(data.pinBlock)
      + "\r\n Clear PIN Block:  " + Common.getHexStringFromBytes(data.clearPinBlock)
      + "\r\n             PAN:  " + data.PAN
      + "\r\n             PIN:  " + data.PIN;
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            if (tBDKdata.Text.Length != 32)
            {
                tResults.Text = "BDK  Error.  Provide a BDK, and make sure they are 16 bytes (32 characters)";
                return;
            }
            if (tKSNdata.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tKSNdata.Text.Length > 20)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if ((tKSNdata.Text.Length % 2) == 1)
            {
                tResults.Text = "KSN incorrect";
                return;
            }


            int type = 1;
            if (aesdata.Checked) type = 2;

            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdesdata.Checked);
            data.isDecryption = true;

            data.keyVariant = 0;


            data.KSN = new byte[10];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSNdata.Text);
            int offset = 10 - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length); data.BDK = Common.getByteArray(tBDKdata.Text);
            data.dataToProcess = Common.getByteArray(tEncryptedDatadata.Text);



            if (Common.processDUKPT(ref data))
            {


                tResults.Text = Common.getHexStringFromBytes(data.dataResults) + "\r\n\r\n" + System.Text.Encoding.UTF8.GetString(data.dataResults);



            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }

            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);

        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (tBDKpin.Text.Length != 32)
            {
                tResults.Text = "BDK  Error.  Provide a BDK, and make sure they are 16 bytes (32 characters)";
                return;
            }
            if (tKSNpin.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tKSNpin.Text.Length > 20)
            {
                tResults.Text = "KSN too large";
                return;
            }
            if ((tKSNpin.Text.Length % 2) == 1)
            {
                tResults.Text = "KSN incorrect";
                return;
            }
            if (tbPANpin.Text.Length < 13 || tbPANpin.Text.Length > 19)
            {
                tResults.Text = "Please enter valid PAN between 13 and 19 digits";
                return;
            }

            int type = 1;
            if (aespin.Checked) type = 2;

            IDTCryptoData data = new IDTCryptoData();
            data.isTDES = (tdespin.Checked);
            data.isDecryption = true;

            data.keyVariant = 1;

            if (tdespin.Checked)
            {
                data.PINBlockType = 0;
            }
            else
            {
                data.PINBlockType = 4;
            }
            data.KSN = new byte[10];
            for (int x = 0; x < data.KSN.Length; x++) data.KSN[x] = 0xff;
            byte[] dataKSN = Common.getByteArray(tKSNpin.Text);
            int offset = 10 - dataKSN.Length;
            System.Array.Copy(dataKSN, 0, data.KSN, offset, dataKSN.Length); data.BDK = Common.getByteArray(tBDKpin.Text);
            data.PAN = tbPANpin.Text;
            data.dataToProcess = Common.getByteArray(tEncryptedDatapin.Text);

            if (data.PAN != null && data.PAN.Length > 0 && data.isDecryption)
            {
                if (data.dataToProcess.Length != 8 && data.isTDES)
                {
                    tResults.Text = "PIN Block must be 8 bytes";
                    return;
                }
                else if (data.dataToProcess.Length != 16 && !data.isTDES)
                {
                    tResults.Text = "PIN Block must be 16 bytes";
                    return;
                }

                if (data.isTDES)
                {
                    data.pinBlock = new byte[8];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 8);
                }
                else
                {
                    data.pinBlock = new byte[16];
                    System.Array.Copy(data.dataToProcess, data.pinBlock, 16);
                }
            }


            if (Common.processDUKPT(ref data))
            {



                tResults.Text = "PIN = " + data.PIN;





            }
            else
            {
                tResults.Text = "Could Not Process Request. Please verify data is complete.";
            }

            if (data.errorString != null && data.errorString.Length > 0)
            {
                tResults.Text = "Error Encountered: " + data.errorString;
                return;
            }

            tResults.Text = tResults.Text +
    "\r\n\r\n           IPEK:  " + Common.getHexStringFromBytes(data.IPEK)
      + "\r\n    Derived Key:  " + Common.getHexStringFromBytes(data.DEK)
      + "\r\n   Data Variant:  " + Common.getHexStringFromBytes(data.DataVariant)
      + "\r\n    PIN Variant:  " + Common.getHexStringFromBytes(data.PINVariant)
      + "\r\n    MAC Variant:  " + Common.getHexStringFromBytes(data.MACVariant);
            if (data.PAN != null && data.PAN.Length > 0)
            {
                tResults.Text = tResults.Text +
    "\r\n\r\n       PIN Block:  " + Common.getHexStringFromBytes(data.pinBlock)
      + "\r\n Clear PIN Block:  " + Common.getHexStringFromBytes(data.clearPinBlock)
      + "\r\n             PAN:  " + data.PAN
      + "\r\n             PIN:  " + data.PIN;
            }

        }
        private void tdes_CheckedChanged(object sender, EventArgs e)
        {
            panelPINBlock.Visible = tdes.Checked;
        }

     
    }
    }
